# WORKFLOW #
***

## 0: Setup (Only done once) ##
First, clone the repository by doing:

    $ git clone https://github.com/paragon/app.git

Next, checkout the remote development branch:

    $ git checkout --track origin/development

## 1: Branches ##
Determine if you want to work on an existing branch or create a new branch.  
Existing Branch:  

    $ git checkout BRANCHNAME
  
(example: `git checkout milestone-1`)  
New Branch:  

    $ git checkout -b NEWBRANCHNAME
  
(example: `git checkout -b new-milestone`)

## 2: Adding the Files ##
Type:  

    $ git status
  
To see a list of all the files modified.  
You will likely see something saying 'Unstaged Files', and then something saying `git add <file>`.  
You should be able to type:  

    $ git add -u
  
Which should stage solely the modified files.  
Type `git status` again to make sure all the files you wish to be committed are set to be committed - you may need to do `git add <file>` on new files you've created.

## 3: Committing ##
Now, you can commit the files by doing:  

    $ git commit -m "COMMIT MESSAGE"
  
You can write whatever you please in place of `COMMIT MESSAGE`, so long as it is wrapped in quotes (avoid double quotes inside the commit message).

## 4: Dealing with the `development` Branch ##
We make sure we are up-to-date with the `development` Branch, and roll local our changes on top.  

    $ git checkout development
    $ git pull
    $ git checkout BRANCHNAME
    $ git rebase development

## 5: Wrap-up ##
We merge our branch into `development`, push it, and (optionally) delete our local Branch.  

    $ git checkout development
    $ git merge BRANCHNAME
    $ git push
    $ git branch -d BRANCHNAME
 
(`git branch -d BRANCHNAME` deletes the branch titled 'BRANCHNAME', but as mentioned prior, is optional)

## 6: Push to Master ##
If you feel your changes should be pushed from Development to Master, follow below:  

    $ git checkout master
    $ git merge development
    $ git tag #.#.#
    $ git push
    $ git push --tags

## Miscellaneous ##
If you do accidentally add files to be Staged (using `git add`) and want to unstage them, do:  

    $ git reset HEAD <file>