"""
config.py

Contains the configuration constants for different stages of development.

Created by Stephen Andrews, September 12th, 2018.
"""
import os

class Config:
    """Base configuration object."""

    BASE_DIR = os.path.abspath(os.path.dirname(__file__))
    VERSION = '0.0.1'

    # URL prefixes
    BOOK_URL_PREFIX = '/book'
    IMAGE_URL_PREFIX = '/image'
    INDEX_URL_PREFIX = '/'
    LIBRARY_URL_PREFIX = '/library'
    LISTING_URL_PREFIX = '/listing'
    MESSAGE_URL_PREFIX = '/messages'
    NOTIFICATION_URL_PREFIX = '/notifications'
    TRANSACTION_URL_PREFIX = '/transactions'
    USER_URL_PREFIX = '/user'
    INTERESTED_LIST_PREFIX = '/interested'

    # Decide on best way to do this...obviously use ENV variable
    ENCRYPTION_KEY = "bushdid911"

    # SQL Alchemy config
    SQLALCHEMY_DATABASE_URI = 'postgresql://admin:eatshit@localhost:5432/app'
    SQLALCHEMY_ECHO = True
    SQLALCHEMY_MIGRATE_REPO = os.path.join(BASE_DIR, 'db_repository')

    # SECURITY
    # This is the secret key that is used for session signing.
    # You can generate a secure key with os.urandom(24)
    SECRET_KEY = 'you-will-never-guess'

    # You can generate the WTF_CSRF_SECRET_KEY the same way as you have
    # generated the SECRET_KEY. If no WTF_CSRF_SECRET_KEY is provided, it will
    # use the SECRET_KEY.
    WTF_CSRF_ENABLED = True
    WTF_CSRF_SECRET_KEY = "reallyhardtoguess"

    # Authentication
    LOGIN_VIEW = "auth.login"
    REAUTH_VIEW = "auth.reauth"
    # Cookies Constants: https://flask-login.readthedocs.io/en/latest/#cookie-settings


class DevelopmentConfig(Config):
    """Configuration for development stages."""

    SQLALCHEMY_TRACK_MODIFICATIONS = True
    DEBUG = True

class StagingConfig(Config):
    """Configuration for staging stage."""

    DEBUG = False
    SQLALCHEMY_DATABASE_URI = 'postgresql://thelibrarian:ilikebooks123@book-stand-dev.cmkhusd3rwab.us-east-2.rds.amazonaws.com:5432/book_stand'
    SQLALCHEMY_TRACK_MODIFICATIONS = False
    #S3 Auth
    AWS_ACCESS_KEY_ID = 'AKIAJPZQHDVJQIDOLETQ'
    AWS_SECRET_ACCESS_KEY = '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'

class ProductionConfig(Config):
    """Configuration for production stage."""

    DEBUG = False

    SQLALCHEMY_DATABASE_URI = 'postgresql://thelibrarian:ZjxbW=Y97BJwbu{@bookstand-prod.cmkhusd3rwab.us-east-2.rds.amazonaws.com:5432/book_stand'
    SQLALCHEMY_TRACK_MODIFICATIONS = False
