from app.extensions import AuditMixin, db

from .book import Book

class OwnedList(db.Model, AuditMixin):
	"""The model for a user's owned books."""
	__tablename__ = 'owned_list'

	id = db.Column(db.Integer, primary_key=True)
	user_id = db.Column(db.Integer, db.ForeignKey('user.id'), nullable=False)
	book_id = db.Column(db.Integer, db.ForeignKey('book.id'), nullable=False)
	visible = db.Column(db.Boolean, default=True, nullable=False)

	def serialize(self):
		j = {}
		j['id'] = self.id
		j['user_id'] = self.user_id
		j['book_id'] = self.book_id
		j['book'] = Book.query.filter_by(id = self.book_id).first().serialize()
		j['visible'] = self.visible

		return j