/**
 * Contains various constants used throughout the app.
 * 
 * NOTE: Constants need to be defiend before they are referenced.
 * @author Stephen Andrews
 */

import url from 'url';
import { NativeModules } from 'react-native';

export const DEV_MODE = true;

/**
 * Get the local IP of the host machine. This is needed to connect to a local
 * API. Simply specifying 'localhost' does not work from an expo server. You can
 * read more about the issue here: https://github.com/storybooks/storybook/issues/1222
 */
getLocalIP = () => {
  // return '192.168.0.109';
  // return '192.168.1.191';
  return url.parse(NativeModules.SourceCode.scriptURL).hostname;
}

// API constants
export const DEV_PORT = 5000; 
export const DEV_API = 'http://' + getLocalIP() + ':' + DEV_PORT;
export const API = 'https://bookstand.io';

// Colors
export const PRIMARY_BLUE = '#457FEE';
export const PRIMARY_GREEN = '#7ADF00';
export const PRIMARY_RED = '#FF495C';