import React, {
  Component
} from 'react';
import {
  View,
  Text,
  StyleSheet,
  Image,
  TouchableOpacity,
} from 'react-native';

import BookEntry from '../../components/BookEntry';
import HorizontalRule from '../../components/HorizontalRule';

import Alert from 'Alert';
import API from '../../API';
import StorageManager from '../../StorageManager';

export default class DisplayItem extends Component {

  onPress = () => { // TODO: Have remove make an API call to remove the book from your library, and have list bring us to create listings screen with some info filled out
    Alert.alert(
      "Selected: " + this.props.item.book.title,
      'What would you like to do?',
      [
        {text: 'Cancel', onPress: () => {}, style:'cancel'},
        {text: 'Remove', onPress: () => {this.onRemove()}}, 
        {text: 'List it', onPress: () => {this.onListIt()}}
      ],
      // { cancelable: false },
      {onDismiss:()=>{}}
    );
  }

  // To remove a book from the library
  onRemove = () => {
    Alert.alert(
      "Remove: " + this.props.item.book.title + " from your library?",
      "",
      [
        {text: 'Cancel', onPress: () => {}, style:'cancel'},
        {text: 'Remove', onPress: () => {this.onConfirmRemove()}},
      ],
      // { cancelable: false },
      {onDismiss:()=>{}}
    );
  }

  // When the user presses remove, then remove again
  onConfirmRemove = () => {
    let cb = (result) => {
      result.json().then((data) => {
      this.props.onRemovedItem(data);
      }, () => {
        this.props.onRemovedItem([]); // TODO: maybe have it so that it will remove the item rather than display an empty array. Who knows; maybe something else caused the issue
      }
      );
    };

    API.removeOwned(this.props.item.id, cb);
  }

  // Naviage to the CreateListing screen and pass book info as params
  onListIt = () => {
    this.props.navigation.navigate('CreateListing', {'bookInfo':this.props.item.book});
  }

  render() {
    return (
      <View style={styles.container}>
        <TouchableOpacity style={styles.touchable} onPress={this.onPress}>
          <BookEntry book={this.props.item.book}></BookEntry>
        </TouchableOpacity>

        <HorizontalRule />
      </View>
    );
  }
}

const styles = StyleSheet.create({
  container: {
    backgroundColor: '#FDFDFE',
    flexGrow: 1,
    paddingLeft: 10,
    paddingRight: 10,
  },
  textContent: {
    flexDirection: 'column'
  },
  touchable: {
    backgroundColor: '#FFFFFF',
    borderRadius: 5,
    flexDirection: 'row',
    padding: 5,
  },
});
