import React, {
  Component
} from 'react';
import {
  View,
  Text,
  StyleSheet,
  Image,
  TouchableOpacity,
} from 'react-native';

import BookEntry from '../../components/BookEntry';
import HorizontalRule from '../../components/HorizontalRule';
import SaleListView from './SaleListView';
import ListingView from './ListingView';

export default class BookEntryItem extends Component {

  onPressAction = () => {
    if (this.props.press) {
      this.props.press(this.props.item.book.isbn_13);
    } else {
      this.props.navigation.navigate('Listings', {screen: <ListingView bookId={this.props.item.book.id} {...this.props}/>});
    }
  }

  render() {
    return (
      <View style={styles.container}>
        <TouchableOpacity
          onPress={() => this.onPressAction()}
          style={styles.touchable}>
          <BookEntry book={this.props.item.book}></BookEntry>
        </TouchableOpacity>

        <HorizontalRule />
      </View>
    );
  }
}

const styles = StyleSheet.create({
  container: {
    backgroundColor: '#FDFDFE',
    flexGrow: 1,
    paddingLeft: 10,
    paddingRight: 10,
  },
  textContent: {
    flexDirection: 'column'
  },
  touchable: {
    backgroundColor: '#FFFFFF',
    borderRadius: 5,
    flexDirection: 'row',
    padding: 5,
  },
});
