/**
 * Defines the login screen.
 * @author Stephen Andrews, Ted Bieber
 */

import React, {
  Component
} from 'react';
import {
  Platform,
  KeyboardAvoidingView,
  View,
  Text,
  StyleSheet,
} from 'react-native';

import ForgotForm from './ForgotForm';

export default class Forgot extends Component {
  render() {
    return (
      <KeyboardAvoidingView behavior="padding" style={styles.container}>
        <View style={styles.headingContainer}>
            <Text style={styles.heading}>Book Stand</Text>
        </View>

        <View style={styles.formContainer}>
            <ForgotForm {...this.props}/>
        </View>
      </KeyboardAvoidingView>
    );
  }
}

const styles = StyleSheet.create({
  container: {
    flex: 1,
    backgroundColor: '#FDFDFE'
  },
  headingContainer: {
    flexGrow: 1,
    justifyContent: 'center'
  },
  heading: {
    color: '#464A53',
    fontSize: 42,
    fontFamily: Platform.OS === 'ios' ? 'Helvetica' : 'Roboto',
    fontWeight: '500',
    marginLeft: 25,
    textAlign: 'center'
  },
  subHeading: {
    color: '#CDCFD1',
    fontSize: 18,
    fontFamily: Platform.OS === 'ios' ? 'Helvetica' : 'Roboto',
    fontWeight: '500',
    marginLeft: 28,
    textAlign: 'center'
  }
});
