import React, {
    Component,
    PureComponent
  } from 'react';
  import {
    Platform,
    View,
    Text,
    StyleSheet,
  } from 'react-native';
  
  import HorizontalRule from '../../components/HorizontalRule';

  import StorageManager from '../../StorageManager';
  import ImageCard from '../../components/ImageCard';

/**
 * Represents an individual transaction.
 * @author Ted Bieber, Stephen Andrews
 * @since 12.6.18
 */
export default class TransactionItem extends PureComponent {

    constructor() {
        super();

        this.state = {
        }
    }

    componentWillMount() {
        
    }

  
    getTitle = (item) => {
        return item.listing.book.title;
    }

    getDate = (item) => {
        return item.slang_created;
    }

    getBuyer = (item) => {
        return "Buyer: " + item.buyer.username;
    }

    getPrice = (item) => { // TODO: Sale/free logic?
        return "$"+item.listing.price;
    }

    renderBoldFont = (text) => {
      return (
        <Text
          style={{
            fontFamily: Platform.OS === 'ios' ? 'Helvetica' : 'Roboto',
            fontSize: 16,
            fontWeight: 'bold'
          }}>
          { text }
        </Text>

        );
    }

    render() {
        return (
        <View style={styles.container}>
          <View style={styles.content}>
            <View style={styles.topContainer}>
                { this.renderBoldFont(this.getTitle(this.props.item)) }
                { this.renderBoldFont(this.getPrice(this.props.item)) }
            </View>

            <View style={styles.bottomContainer}>
                <Text style={styles.p}>{this.getBuyer(this.props.item)}</Text>
                <Text style={styles.p}>{this.getDate(this.props.item)}</Text>
            </View>            
          </View>

          <HorizontalRule />
        </View>
        );
    }
}

const styles = StyleSheet.create({
  container: {
    backgroundColor: '#FDFDFE',
    flex: 1,
  },
  content: {
    paddingVertical: 10,
  },
  title: {
    textAlign:'left',
    flex:1,
    fontWeight: 'bold'
  },
  price: {
    flex:1,
    fontWeight: 'bold'
  },
  topContainer: {
    flexDirection: 'row',
    justifyContent: 'space-between',
    marginBottom: 5,
  },
  bottomContainer: {
    flexDirection: 'row',
    justifyContent: 'space-between',
  },
  p: {
    fontFamily: Platform.OS === 'ios' ? 'Helvetica' : 'Roboto',
  }

});
